// ContinuousTime.h: interface for the ContinuousTime class.
//
//////////////////////////////////////////////////////////////////////

#ifndef CONTINUOUSTIME_H
#define CONTINUOUSTIME_H

#ifndef SWIG
#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
#endif // SWIG

#include "SpinDynamics.h"
#include <deque>

class Point		// Gives (i,j) coordinates of a spin
{
public:
	int j;
	int i;
	Point() {};
	virtual ~Point() {};

};

#ifndef SWIG
typedef std::deque<Point> pointVector;
#endif	// SWIG

class ContinuousTime : public SpinDynamics
{
public:
	virtual double Sweep();
	void ResetLattice(SpinLattice* S);
	void SetMagneticField(double magneticField);
	void SetTemperature(double temperature);
	ContinuousTime(SpinLattice *S);
	virtual ~ContinuousTime();

protected:
	void SetupLOOKLOC();
	void FixLOOKLOC(Point& ij, int dNUp, int ds);
	void SetProbFlip();
	double probFlip[2][5];
	int ** LOOK;
#ifndef SWIG
	pointVector LOC[2][5];	// LOC[s][nUp][n].i = i of nth point with spin s and nUp neighbors; ditto j
#endif // SWIG

};

#endif // !defined(CONTINUOUSTIME_H)
