// CorrelationObserverFFT.h: interface for the CorrelationObserverFFT class.
//
//////////////////////////////////////////////////////////////////////

#ifndef CORRELATIONOBSERVERFFT_H
#define CORRELATIONOBSERVERFFT_H

#ifndef SWIG
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

extern "C" void zfft1dc(double*,double*,int,int,double*);
#endif // SWIG


#include "SubjectObserver.h"
#include "IsingSimulation.h"

class CorrelationObserverFFT : public Observer  
{
public:

	void Reset();
	void Update(Subject *sim);
	CorrelationObserverFFT();
	virtual ~CorrelationObserverFFT();
	double Correlation(int r)
	{
		if (r < 0) return Correlation(-r);
		if (r <= width/2) return ((double) correlationFunction[r])/(numberAveraged*width);
		return 0.0;
	}

protected:
	int width;
	int numberAveraged;
	double *correlationFunction;
	double *FTreal;
	double *FTimag;
	double *wsave;
	void Allocate(int m);
};

#endif // !defined CORRELATIONOBSERVERFFT_H