// CorrelationObserverSlow.h: interface for the CorrelationObserverSlow class.
//
//////////////////////////////////////////////////////////////////////

#ifndef CORRELATIONOBSERVERSLOW_H
#define CORRELATIONOBSERVERSLOW_H

#ifndef SWIG
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#endif // SWIG

#include "SubjectObserver.h"
#include "IsingSimulation.h"

class CorrelationObserverSlow : public Observer  
{
public:
	void Reset();
	void Update(Subject * sim);
	CorrelationObserverSlow();
	virtual ~CorrelationObserverSlow();
	double Correlation(int r) const
	{
		if (r < 0) return Correlation(-r);
		if (r == 0) return correlationFunction[r];
		if (r <= width/2) 
			return ((double) (correlationFunction[r]+correlationFunction[width-r]))
						/(numberAveraged*width);
		return 0.0;
	}

protected:
	int width;
	int numberAveraged;
	double* correlationFunction;

};

#endif // !defined(CORRELATIONOBSERVERSLOW_H)
