// MagnetizationObserver.cpp: implementation of the MagnetizationObserver class.
//
//////////////////////////////////////////////////////////////////////

#include "MagnetizationObserver.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
// #define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

MagnetizationObserver::MagnetizationObserver()
{
	Reset();
}

MagnetizationObserver::~MagnetizationObserver()
{
}

void MagnetizationObserver::Update(Subject *sim)
{
	IsingSimulation *ising = (IsingSimulation *)sim;

	// Need temperature, total # of spins for C
	if ( (numberSpins != ising->GetWidth() * ising->GetHeight()) ||
		 (temperature != ising->GetTemperature()) )	
	{
		numberSpins = ising->GetWidth() * ising->GetHeight();
		temperature = ising->GetTemperature();
		Reset();									// Reset when lattice size changes!
	}
	double m = ising->GetLattice()->GetMagnetization();
	mtot += m;
	numMtot ++;
	m2tot += m*m;
}

void MagnetizationObserver::Reset()
{
	mtot = m2tot = 0.0;
	numMtot = 0;
}

double MagnetizationObserver::Susceptibility()
{
	if (numMtot < 2) return 1.0;

	return (m2tot - mtot*mtot/numMtot)/((numMtot-1) * numberSpins * temperature);	// Check? XXX ???
}
