// MagnetizationObserver.h: interface for the MagnetizationObserver class.
//
//////////////////////////////////////////////////////////////////////

#ifndef MAGNETIZATIONOBSERVER_H
#define MAGNETIZATIONOBSERVER_H

#ifndef SWIG
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#endif

#include "SubjectObserver.h"
#include "IsingSimulation.h"

class MagnetizationObserver : public Observer  
{
public:
	double Susceptibility();
	double Mbar() const {
		if (numMtot == 0) return 0;
		else return mtot/(numMtot*numberSpins);}
	double NumberReadings() const {return numMtot;}
	void Reset();
	virtual void Update(Subject *sim);
	MagnetizationObserver();
	virtual ~MagnetizationObserver();

private:
	double mtot;
	double m2tot;
	int numMtot;
	double temperature;

protected:
	double numberSpins;
};

#endif // !defined(MAGNETIZATIONOBSERVER_H)
