// Observer.h: interface for the Observer class.
//
//////////////////////////////////////////////////////////////////////

#ifndef OBSERVER_H
#define OBSERVER_H

#ifndef SWIG
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#endif

#include <list>

class Subject;

class Observer  
{
public:
	virtual ~Observer() {};
	virtual void Update(Subject *theChangedSubject) = 0;

protected:
	Observer() {};
};


class Subject  
{
public:
	virtual ~Subject() {
		delete _observers;};
	virtual void  Attach(Observer* o) {
		_observers->push_back(o);
	}
	virtual void Detach(Observer* o) {
		_observers->remove(o);
	}
	virtual void Notify() {
		std::list<Observer*>::iterator i = _observers->begin();
		while (i != _observers->end()) {
			(*i)->Update(this);
			i++;
		}
	}

protected:
#ifndef SWIG // XXX
	Subject() {
		_observers = new std::list<Observer*>;}
#endif // SWIG
private:
#ifndef SWIG // XXX
	std::list<Observer*> *_observers;
#endif // SWIG
};

#endif // !defined(OBSERVER_H)
